using System;
using System.Windows.Forms;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Messaging;
using System.Runtime.Remoting.Proxies;
using System.Reflection;

namespace DeviceHook
{
	/// <summary>
	/// Microsoft.DirectX.Direct3D.Device ɑ΂vLV
	/// </summary>
	public class DeviceProxy : RealProxy
	{
		static public Device CreateDevice(
			int adapter,
			DeviceType type,
			Control window,
			CreateFlags flags,
			PresentParameters param )
		{
			Device target = new Device( adapter, type, window, flags, param );

			DeviceProxy proxy = new DeviceProxy( target, typeof(Device) );
			return (Device) proxy.GetTransparentProxy();			
		}
		static public Device CreateDevice(
			int adapter,
			DeviceType type,
			IntPtr handle,
			CreateFlags flags,
			PresentParameters param )
		{
			Device target = new Device( adapter, type, handle, flags, param );
			DeviceProxy proxy = new DeviceProxy( target, typeof(Device) );
			return (Device) proxy.GetTransparentProxy();			
		}
		private readonly MarshalByRefObject target;
		public DeviceProxy( MarshalByRefObject target, Type type) : base(type)
		{
			this.target = target;
		}
		/// <summary>
		/// 荞݃nh
		/// </summary>
		/// <param name="msg">荞݂ Call bZ[W</param>
		/// <returns>荞݂ Return bZ[W</returns>
		public override IMessage Invoke(IMessage msg)
		{
			// Call bZ[W
			IMethodCallMessage call = (IMethodCallMessage) msg;
			// Return bZ[W
			IMethodReturnMessage ret = ExecuteMessage( call );
			
			if( ret.Exception != null )
			{
				string str = string.Format( "\bh : {0}\nbZ[W : {1}",
					call.MethodName, ret.Exception.Message );
				MessageBox.Show( str, "ExecuteMessage" );
			}
			return ret;
		}
		public unsafe IMethodReturnMessage ExecuteMessage( IMethodCallMessage call )
		{
			if( call.MethodName == "FieldGetter"
				&& call.InArgCount > 2 && ((string)call.InArgs[1]) == "m_lpUM" )
			{
				Type type = typeof(Device);
				FieldInfo info
					= type.GetField( "m_lpUM", BindingFlags.NonPublic | BindingFlags.Instance);
				object retval = info.GetValue( target );
				unsafe
				{
					void* rawptr = System.Reflection.Pointer.Unbox( retval );
					IntPtr ptr = new IntPtr( rawptr );
					return new ReturnMessage( typeof(void), new object[]{null,null,ptr},
						3, call.LogicalCallContext, call );
				}
			}
			else
			{
				return RemotingServices.ExecuteMessage( target, call );
			}
		}
	}
}